
package de.codedo.conflicteditor.gui;

import de.codedo.conflicteditor.Difference;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableModel;

public class ConflictEditor
{
    private ConflictEditorFrame _frame;

    public static void main(String[] args)
    {
        try
        {
            new ConflictEditor().run();
        }
        catch (Exception ex)
        {
            System.out.println("Uncaught toplevel Exception");
            ex.printStackTrace(System.out);
        }
    }

    private void run()
    {
        _frame = new ConflictEditorFrame();
        connectListeners(_frame);
        _frame.pack();
        _frame.setVisible(true);
    }

    private void connectListeners(ConflictEditorFrame frame)
    {
        frame.getConnectButton().addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                connectAndFindConflicts();
            }
        });

        frame.getConflictsTable().getSelectionModel().addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e)
            {
                selectConflict();
            }
        });
    }

    protected void connectAndFindConflicts()
    {
        List<Difference> diffs = new ArrayList<Difference>();
        diffs.add(new Difference("key", "current", "other"));

        TableModel model = new DifferenceTableModel(diffs);
        _frame.getConflictsTable().setModel(model);
    }

    protected void selectConflict()
    {
        System.out.println("select a conflict");
    }
}
