
package de.codedo.conflicteditor.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.HeadlessException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableModel;

public class ConflictEditorFrame extends JFrame
{
    private JTextField _databaseUrlTextField;
    private JButton _connectButton;
    private JTable _conflictsTable;

    public ConflictEditorFrame() throws HeadlessException
    {
        super();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new BorderLayout());
        buildGui();
    }

    private void buildGui()
    {
        buildDatabaseUrlPanel();
        buildConflictsTable();
    }

    private void buildDatabaseUrlPanel()
    {
        JLabel label = new JLabel("Database URL:");
        _databaseUrlTextField = new JTextField(40);
        _connectButton = new JButton("Connect");

        JPanel databaseUrlPanel = new JPanel();
        databaseUrlPanel.setLayout(new FlowLayout());
        databaseUrlPanel.add(label);
        databaseUrlPanel.add(_databaseUrlTextField);
        databaseUrlPanel.add(_connectButton);

        getContentPane().add(databaseUrlPanel);
    }

    private void buildConflictsTable()
    {
        _conflictsTable = new JTable();
        TableModel model = new DifferenceTableModel();
        _conflictsTable.setModel(model);

        JScrollPane scrollPane = new JScrollPane(_conflictsTable);
        getContentPane().add(scrollPane, BorderLayout.SOUTH);
    }

    public JButton getConnectButton()
    {
        return _connectButton;
    }

    public JTable getConflictsTable()
    {
        return _conflictsTable;
    }
}
